import 'dart:async';
import 'dart:convert';
import 'dart:io' show Platform;
import 'package:device_info/device_info.dart';
import 'package:fk_user_agent/fk_user_agent.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter_conscent_plugin/paywalls/flutter_flow/flutter_flow_theme.dart';
import 'package:flutter_conscent_plugin/paywalls/flutter_flow/flutter_flow_util.dart';
import 'package:flutter_conscent_plugin/paywalls/in_article_50pageblock_3_a_3_c_t_a/in_article50pageblock3_a3_c_t_a_widget.dart';
import 'package:flutter_conscent_plugin/paywalls/in_article_8_a_1_c_t_a/in_article8_a1_c_t_a_widget.dart';
import 'package:flutter_conscent_plugin/paywalls/inarticle_5_a_3_c_t_a/inarticle5_a3_c_t_a_widget.dart';
import 'package:flutter_conscent_plugin/paywalls/inarticle_7_a_1_c_t_a/inarticle7_a1_c_t_a_widget.dart';
import 'package:flutter_conscent_plugin/paywalls/inarticle_8_a_2_c_t_a/inarticle8_a2_c_t_a_widget.dart';
import 'package:http/http.dart' as http;
import 'package:shared_preferences/shared_preferences.dart';
import 'package:uuid/uuid.dart';
import 'conscent_initializer.dart';
import 'constants.dart';
import 'datamodel/api_mode.dart';
import 'datamodel/content_access_model.dart';
import 'datamodel/content_details2.dart';
import 'datamodel/getuser_detail.dart';
import 'datamodel/login_challenge_post.dart';
import 'datamodel/login_challengeget.dart';
import 'datamodel/logout.dart';
import 'datamodel/page_view_event.dart';
import 'datamodel/paywall_click_event.dart';
import 'datamodel/paywall_config.dart';
import 'datamodel/paywall_view_event.dart';
import 'datamodel/subscription_access_model.dart';
import 'shared_pref.dart';
import 'defaultSubscribtion.dart';

var _messageBodyData = MessageBody();
var _messageBodyDataEvent = MessageBodyEvent();
var _messageBodyPageView = PageViewMessageBody();

class ConscentMethods {
  ContentAccessModel? contentAccessModel;

  String? loginId;
  Future<ContentAccessModel?> getContentAccess() async {
    ConscentMethods()._getPaywallDetails();
    final prefs = await SharedPreferences.getInstance();
    var loginId = prefs.getString('loginID');
    print("loginId $loginId");
    if (loginId == null) {
      LoginChallengepost loginChallengepost = await _createLogInChallenge();

      loginId = loginChallengepost.loginChallengeId;
    }
    var responseData = await _getSessionID(loginId.toString());
    return responseData;
  }

  Future<void> _getPaywallDetails() async {
    String? userId = await SharedPref().getUserId();
    if(userId != null && userId.isNotEmpty){
      Constants.logIn = true;
    }
    final prefs = await SharedPreferences.getInstance();
    String? sessionId = prefs.getString("sessionId");
    var url = Uri.parse(
        '${APIMode.BASE_URL}api/v1/content?clientId=${ConscentInitializer.mClientId}&clientContentId=${ConscentInitializer.mContentId}&sessionId=$sessionId');
    var response = await http.get(url);
    if (response.statusCode == 200) {
      ContentDetails2 contentDetails2 =
          ContentDetails2.fromJson(json.decode(response.body));
      Constants.contentDetails2 = contentDetails2;
      Constants.contentDetails2?.couponForPass?.code = "";
      Constants.conscentBalance =
          contentDetails2.userDetails?.wallet?.balance?.numberDecimal;

    } else {
      onPluginError(response.body);
    }
  }

  Future<String> _createAndGetLogInChallenge() async {
    final prefs = await SharedPreferences.getInstance();
    String? loginId = prefs.getString('loginID');
    var response;
    if(loginId == null){
      response = await http.post(Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge'), body: {
        "loginChallengeId": '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4()}',
        "redirectTo": ""
      });
    }else{
      return loginId;
    }

    if (response.statusCode == 201) {
      var responseString = response.body;
      String loginChallengeId =
          loginChallengepostFromJson(responseString).loginChallengeId;
      final prefs = await SharedPreferences.getInstance();
      await prefs.setString('loginID', loginChallengeId);
      return loginChallengeId;
    } else {
      conscentMethods?.onPluginError(response.body);
      throw Exception('Failed to create album.');
    }
  }

  Future<String> prepareLoginChallenge(List<String> append) async {
    String redirectUrl;
    String? subscriptionUrl;
    String? subscriptionDomain = "";

    subscriptionUrl = Constants.contentDetails2?.subscriptionUrl;
    subscriptionDomain = Constants.contentDetails2?.subscriptionDomain;
    SharedPref().setSubsUrl(subscriptionUrl!);

    String? loginChallengeId = await SharedPref().getLoginId();
    if (loginChallengeId == null && loginChallengeId == "") {
      var response = await http
          .post(Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge'), body: {
        "loginChallengeId":
            '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4()}',
        "redirectTo": ""
      });

      if (response.statusCode == 201) {
        var responseString = response.body;
        loginChallengeId =
            loginChallengepostFromJson(responseString).loginChallengeId;

        await SharedPref().setLoginId(loginChallengeId);
      } else {
        onPluginError(response.body);
      }
    }
    if (append.first == "content") {
      redirectUrl =
          '${APIMode.SERVICE_BASE_URL}/overlay?clientId=${ConscentInitializer.mClientId}&clientContentId=${ConscentInitializer.mContentId}&loginChallenge=$loginChallengeId';
      return redirectUrl;
    } else if (append.first == "pass") {
      redirectUrl =
          '${APIMode.SERVICE_BASE_URL}/overlay?clientId=${ConscentInitializer.mClientId}&clientContentId=${ConscentInitializer.mContentId}&loginChallenge=$loginChallengeId&purchaseMode=PASS';
      return redirectUrl;
    } else if (append.first == "subscription") {
      redirectUrl =
          'https://$subscriptionDomain/${append.last}?clientId=${ConscentInitializer.mClientId}&clientContentId=${ConscentInitializer.mContentId}&loginChallenge=$loginChallengeId';

      return redirectUrl;
    } else {
      redirectUrl =
          '${APIMode.SERVICE_BASE_URL}/overlay?clientId=${ConscentInitializer.mClientId}&clientContentId=${ConscentInitializer.mContentId}&loginChallenge=$loginChallengeId';
      return redirectUrl;
    }
  }

  Future<LoginChallengepost> _createLogInChallenge() async {
    var response = await http
        .post(Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge'), body: {
      "loginChallengeId":
          '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4()}',
      "redirectTo": ""
    });

    if (response.statusCode == 201) {
      var responseString = response.body;
      String loginChallengeId =
          loginChallengepostFromJson(responseString).loginChallengeId;
      final prefs = await SharedPreferences.getInstance();

      await prefs.setString('loginID', loginChallengeId);

      return loginChallengepostFromJson(responseString);
    } else {
      onPluginError(response.body);
      throw Exception('Failed to create album.');
    }
  }

  Future<ContentAccessModel?> _getSessionID(String loginId) async {
    var uri = Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge/$loginId');
    var response = await http.get(uri);
    if (response.statusCode == 200) {
      final prefs = await SharedPreferences.getInstance();

      LoginChallengeget loginChallengeget =
          loginChallengegetFromJson(response.body);
      String sessionId = loginChallengeget.sessionId.toString();

      prefs.setString('sessionId', sessionId);

      var responseDta = await _submitDatas(
          ConscentInitializer.mClientId.toString(),
          ConscentInitializer.mContentId.toString(),
          sessionId);
      return responseDta;
    } else {
      onPluginError(response.body);
    }
  }

  Future<ContentAccessModel?> _submitDatas(
    String clientId,
    String clientContentId,
    String sessionId,
  ) async {

    print("sessionId $sessionId");

    var response = await http
        .post(Uri.parse('${APIMode.BASE_URL}api/v1/content/access'), body: {
      "clientId": clientId,
      "clientContentId": clientContentId,
      "sessionId": sessionId,
    });

    if (response.statusCode == 201) {
      contentAccessModel =
          ContentAccessModel.fromJson(jsonDecode(response.body));

      if (contentAccessModel?.sessionExists == null &&
          contentAccessModel?.accessTimeLeft == null) {
        onPluginError(response.body);
      }
      Constants.freeAccess = contentAccessModel?.freeAccess;
      if (contentAccessModel?.signature != null) {
        if (contentAccessModel?.unlockedWithPass == true) {
          Constants.accessType = "PASS";
        }
        if (contentAccessModel?.unlockedWithSubscription == true) {
          Constants.accessType = "SUB";
        }
        Constants.accessType = "CONTENT";
      }
      bool? sessionExists = false;
      sessionExists = contentAccessModel?.sessionExists;
      Constants.sessionExists = sessionExists!;
      return contentAccessModel;
    } else {
      onPluginError(response.body);
    }
  }

  // methods for subscription
  Future<SubscriptionAccess?> geSubscriptionAccess() async {
    final prefs = await SharedPreferences.getInstance();
    loginId = prefs.getString('loginID');

    var responDtta = await getSessionIDForSubs(loginId.toString());
    return responDtta;
  }

  Future<SubscriptionAccess?> getSessionIDForSubs(String loginId) async {
    var uri = Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge/$loginId');

    var response = await http.get(uri);
    if (response.statusCode == 200) {
      final prefs = await SharedPreferences.getInstance();
      LoginChallengeget loginChallengeget =
          loginChallengegetFromJson(response.body);

      String sessionId = loginChallengeget.sessionId.toString();
      prefs.setString('sessionId', sessionId);
      var responseDta = await getPstssForSubs();
      return responseDta;
    } else {
      onPluginError(response.body);
    }
  }

  Future<SubscriptionAccess?> getPstssForSubs() async {
    final prefs = await SharedPreferences.getInstance();
    var sessionIds = prefs.getString('sessionId');
    var uri = Uri.parse(
        '${APIMode.BASE_URL}api/v1/subscription/access?sessionId=$sessionIds&clientId=${ConscentInitializer.mClientId}');

    var response = await http.get(uri);
    if (response.statusCode == 200) {
      var subscription_Access =
          SubscriptionAccess.fromJson(jsonDecode(response.body));

      return subscription_Access;
    } else {
      onPluginError(response.body);
    }
  }

  Future<String?> userLogOut() async {
    final prefs = await SharedPreferences.getInstance();
    String? sessionId = prefs.getString('sessionId');
    Constants.logIn = false;
    print('userLogOut sessionId = $sessionId');

    String? logout;
    var response;
    if(sessionId != null){
      response = await http.post(
          Uri.parse(
              '${APIMode.BASE_URL}api/v1/auth/logout-via-sessionid?sessionId=$sessionId'),
          body: {
            "sessionId": sessionId,
          });

      if (response.statusCode == 201) {
        logout = logoutFromJson(response.body).message;
      } else {
        onPluginError(response.body);
        logout = logoutFromJson(response.body).error;
      }
    }else{
      response = await http.post(
          Uri.parse(
              '${APIMode.BASE_URL}api/v1/auth/logout-via-sessionid?sessionId=$sessionId'),
          body: {
            "sessionId": "",
          });

      if (response.statusCode == 201) {
        logout = logoutFromJson(response.body).message;
      } else {
        onPluginError(response.body);
        logout = logoutFromJson(response.body).error;
      }
    }

    prefs.remove("sessionId");
    prefs.remove("anonId");
    prefs.remove("ANONID");
    prefs.remove("userType");
    prefs.remove("loginID");
    prefs.remove("userID");

    return logout;
  }

  Future<GetUserDetail?> getUser() async {
    GetUserDetail? getUserDetail;

    final prefs = await SharedPreferences.getInstance();
    String? sessionId = await SharedPref().getSessionId();
    sessionId = prefs.getString('sessionId');

    var uri = Uri.parse(
        '${APIMode.BASE_URL}api/v1/user/$sessionId?clientId=${ConscentInitializer.mClientId}');
    var response = await http.get(uri);

    if (response.statusCode == 200) {
      getUserDetail = GetUserDetail.fromJson(jsonDecode(response.body));
      return getUserDetail;
    } else {
      onPluginError(response.body);
    }
    return getUserDetail;
  }

  Future<PaywallConfig> getPaywallConfig() async {
    PaywallConfig paywallConfig = PaywallConfig();

    var uri = Uri.parse(
        '${APIMode.BASE_URL}api/v1/paywall/paywall-config/${ConscentInitializer.mClientId}');
    var response = await http.get(uri);

    if (response.statusCode == 200) {
      paywallConfig = PaywallConfig.fromJson(jsonDecode(response.body));
      return paywallConfig;
    } else {
      onPluginError(response.body);
    }

    return paywallConfig;
  }

  Future<void> getOSVersion() async {
    await FkUserAgent.init();
    Constants.userAgent = FkUserAgent.webViewUserAgent;
    DeviceInfoPlugin deviceInfo = DeviceInfoPlugin();
    if (Platform.isAndroid) {
      AndroidDeviceInfo androidInfo = await deviceInfo.androidInfo;
      Constants.osVersion = androidInfo.version.release;
      Constants.mobileModel = androidInfo.model;
      Constants.osName = "Android";
    } else if (Platform.isIOS) {
      IosDeviceInfo iosDeviceInfo = await deviceInfo.iosInfo;

      Constants.osVersion = iosDeviceInfo.systemVersion;
      Constants.mobileModel = iosDeviceInfo.model;
      Constants.osName = "Iphone";
    }
  }

  // Paywall View Event
  Future<void> paywallViewEvent() async {
    await ConscentMethods().getOSVersion();
    var anonId = await SharedPref().getAnonId();

    anonId ??= '${Uuid().v4()}';
    await SharedPref().setAnonId(anonId);

    DateFormat dateFormat = DateFormat("yyyy-MM-dd HH:mm:ss");

    String createdAt = dateFormat.format(DateTime.now());

    _messageBodyData.id = '${Uuid().v4()}';
    _messageBodyData.clientId = ConscentInitializer.mClientId;
    _messageBodyData.contentId = ConscentInitializer.mContentId;
    _messageBodyData.anonId = anonId;
    _messageBodyData.userId = await SharedPref().getUserId();
    _messageBodyData.createdAt = createdAt;
    _messageBodyData.updatedAt = createdAt;
    _messageBodyData.deviceType = "Mobile";
    _messageBodyData.eventLocation = "PAYWALL";
    _messageBodyData.eventType = "VIEW";
    _messageBodyData.paywallDisplayType = "INARTICLE";
    _messageBodyData.isCookieBlocked = 0;
    _messageBodyData.numOfCta = Constants.numOfCta;

    if (Constants.paywallConfig.data != null) {
      _messageBodyData.paywallId = Constants.paywallConfig.data?.sId;
      _messageBodyData.numOfCta = Constants
          .paywallConfig.data?.configuration?.mobile?.templateId?.numberOfCta;
      _messageBodyData.paywallType = Constants
          .paywallConfig.data?.configuration?.mobile?.templateId?.paywallType;
      _messageBodyData.paywallDisplayType = Constants
          .paywallConfig.data?.configuration?.mobile?.templateId?.displayType;
    }

    _messageBodyData.osVersion = Constants.osVersion;
    _messageBodyData.mobileModel = Constants.mobileModel;
    _messageBodyData.osName = Constants.osName;
    _messageBodyData.userAgent = Constants.userAgent;

    var paywallViewEvent = PaywallViewEvent(messageBody: [_messageBodyData]);
    paywallViewEvent.topic = "demoTopic";


    final headers = {'Content-Type': 'application/json'};
    Map<String, dynamic> body = paywallViewEvent.toJson();
    String jsonBody = json.encode(body);
    final encoding = Encoding.getByName('utf-8');
    var response = await http.post(
      Uri.parse('${APIMode.EVENT_BASE_URL}/collect/event'),
      headers: headers,
      body: jsonBody,
      encoding: encoding,
    );
  }

  //Click Event

  Future<void> paywallClickEvent(String clickAction) async {
    pageViewDisposeEvent(0, 0);
    await ConscentMethods().getOSVersion();
    var anonId = await SharedPref().getAnonId();
    anonId ??= '${Uuid().v4()}';
    DateFormat dateFormat = DateFormat("yyyy-MM-dd HH:mm:ss");
    String createdAt = dateFormat.format(DateTime.now());

    _messageBodyDataEvent.id = '${Uuid().v4()}';
    _messageBodyDataEvent.clientId = ConscentInitializer.mClientId;
    _messageBodyDataEvent.contentId = ConscentInitializer.mContentId;
    _messageBodyDataEvent.anonId = anonId;
    _messageBodyDataEvent.userId = await SharedPref().getUserId();
    _messageBodyDataEvent.createdAt = createdAt;
    _messageBodyDataEvent.updatedAt = createdAt;
    _messageBodyDataEvent.deviceType = "Mobile";
    _messageBodyDataEvent.isCookieBlocked = 0;

    _messageBodyDataEvent.paywallType = "Default";
    _messageBodyDataEvent.paywallDisplayType = "INARTICLE";
    _messageBodyDataEvent.numOfCta = Constants.numOfCta;

    if (Constants.paywallConfig.data != null) {
      _messageBodyDataEvent.paywallId = Constants.paywallConfig.data?.sId;
      _messageBodyDataEvent.numOfCta = Constants
          .paywallConfig.data?.configuration?.mobile?.templateId?.numberOfCta;
      _messageBodyDataEvent.paywallType = Constants
          .paywallConfig.data?.configuration?.mobile?.templateId?.paywallType;
      _messageBodyDataEvent.paywallDisplayType = Constants
          .paywallConfig.data?.configuration?.mobile?.templateId?.displayType;
    }
    _messageBodyDataEvent.osVersion = Constants.osVersion;
    _messageBodyDataEvent.mobileModel = Constants.mobileModel;
    _messageBodyDataEvent.osName = Constants.osName;
    _messageBodyDataEvent.userAgent = Constants.userAgent;
    _messageBodyDataEvent.clickAction = clickAction;
    _messageBodyDataEvent.eventLocation = "PAYWALL";
    _messageBodyDataEvent.eventType = "CLICK";
    var paywallViewClickEvent =
        PaywallClickEvent(messageBody: [_messageBodyDataEvent]);
    paywallViewClickEvent.topic = "demoTopic";
    final headers = {'Content-Type': 'application/json'};
    Map<String, dynamic> body = paywallViewClickEvent.toJson();
    String jsonBody = json.encode(body);
    final encoding = Encoding.getByName('utf-8');

    var response = await http.post(
      Uri.parse('${APIMode.EVENT_BASE_URL}/collect/event'),
      headers: headers,
      body: jsonBody,
      encoding: encoding,
    );

  }

  void onTapFun() {

    if (Constants.idleTimeSpent < 10) {
      Constants.idleTimeSpent = 0;
    } else {
      Constants.totalIdleTimeSpent =
          Constants.totalIdleTimeSpent + Constants.idleTimeSpent;
      Constants.idleTimeSpent = 0;
    }
  }

  static Timer? _timer;
  Future<void> pageViewDisposeEvent(double heights, double onScollDepth) async {
    if (_messageBodyPageView.pageLength == 0 ||
        _messageBodyPageView.pageLength == null) {
      _messageBodyPageView.pageLength = heights.toInt();
    }

    var anonId = await SharedPref().getAnonId();
    anonId ??= '${Uuid().v4()}';
    _messageBodyPageView.anonId = anonId;
    if (_messageBodyPageView.scrollDepth == 0 ||
        _messageBodyPageView.scrollDepth == null) {
      _messageBodyPageView.scrollDepth = onScollDepth.toInt();
    }
    int idealTime = 0;
    if (Constants.totalIdleTimeSpent == 0) {
      idealTime = Constants.idleTimeSpent;
      if (idealTime < 10) {
        idealTime = 0;
      }
    } else {
      if (Constants.idleTimeSpent > 10) {
        idealTime = Constants.totalIdleTimeSpent;
      }
    }
    int? totalTimeSpend = Constants.totalTime;


    int activeTime = totalTimeSpend - idealTime;
    if (activeTime < 0) {
      activeTime *= -1;
    }
    _messageBodyPageView.idleTimeSpent = idealTime;
    _messageBodyPageView.activeTimeSpent = activeTime;
    _messageBodyPageView.totalTimeSpent = totalTimeSpend;
    _messageBodyPageView.unlockedStatus = Constants.sessionExists;
    _messageBodyPageView.accessType = Constants.accessType;
    Constants.totalTime = 0;
    Constants.idleTimeSpent = 0;
    Constants.totalIdleTimeSpent = 0;

    _timer?.cancel();

    var paywallViewEvent = PageViewEvent(messageBody: [_messageBodyPageView]);
    paywallViewEvent.topic = "demoTopic";
    final headers = {'Content-Type': 'application/json'};
    Map<String, dynamic> body = paywallViewEvent.toJson();
    String jsonBody = json.encode(body);
    final encoding = Encoding.getByName('utf-8');
    var response = await http.post(
      Uri.parse('${APIMode.EVENT_BASE_URL}/collect/event'),
      headers: headers,
      body: jsonBody,
      encoding: encoding,
    );

  }

  Future<void> pageViewEvent(double heights, double onScollDepth) async {

    await ConscentMethods().getOSVersion();

    _timer = Timer.periodic(const Duration(seconds: 1), (timer) {
      Constants.totalTime = Constants.totalTime + 1;
      Constants.idleTimeSpent = Constants.totalTime;

    });
    var uuid = '${Uuid().v4()}';

    var anonId = await SharedPref().getAnonId();
    var userType = await SharedPref().getUserType();
    userType ??= "NEW";

    anonId ??= '${Uuid().v4()}';

    DateFormat dateFormat = DateFormat("yyyy-MM-dd HH:mm:ss");
    String createdAt = dateFormat.format(DateTime.now());
    _messageBodyPageView.id = uuid;
    _messageBodyPageView.anonId = anonId;
    _messageBodyPageView.userId = await SharedPref().getUserId();
    _messageBodyPageView.userType = userType;
    _messageBodyPageView.deviceType = 'Mobile';
    _messageBodyPageView.browser = "";
    _messageBodyPageView.userAgent = Constants.userAgent;
    _messageBodyPageView.eventType = "VIEW";
    _messageBodyPageView.eventLocation = "PAGE";
    _messageBodyPageView.clientId = '${ConscentInitializer.mClientId}';
    _messageBodyPageView.osName = Constants.osName;
    _messageBodyPageView.userAgent = Constants.userAgent;
    _messageBodyPageView.contentId = '${ConscentInitializer.mContentId}';
    _messageBodyPageView.createdAt = createdAt;
    _messageBodyPageView.updatedAt = createdAt;
    if (_messageBodyPageView.pageLength == 0 ||
        _messageBodyPageView.pageLength == null) {
      _messageBodyPageView.pageLength = heights.toInt();
    }
    if (_messageBodyPageView.scrollDepth == 0 ||
        _messageBodyPageView.scrollDepth == null) {
      _messageBodyPageView.scrollDepth = onScollDepth.toInt();
    }
    if (Constants.freeAccess == true) {
      _messageBodyPageView.premiumContent = false;
    } else {
      _messageBodyPageView.premiumContent = true;
    }

    _messageBodyPageView.pageType = "APP";

    _messageBodyPageView.osVersion = Constants.osVersion;
    _messageBodyPageView.mobileModel = Constants.mobileModel;
    await SharedPref().setUserType("REPEAT");
  }

  void onPluginError(String error) {
    if (kDebugMode) {
      print('onPluginError: $error');
    }
    debugPrint('onPluginError debugPrint: $error');
  }

  void onDebugPrint(String message){
    print('message: $message');
  }
}

class Paywall extends StatefulWidget {
  Function(String) sessionCallback;
  Paywall(this.sessionCallback, {Key? key}) : super(key: key);

  @override
  _Paywall createState() => _Paywall();
}

class _Paywall extends State<Paywall> {
  final scaffoldKey = GlobalKey<ScaffoldState>();

  @override
  void initState() {
    ConscentMethods()._getPaywallDetails();
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      // onTap: () => FocusScope.of(context).requestFocus(_unfocusNode),
      child: Align(
        alignment: const AlignmentDirectional(0, 1),
        child: FutureBuilder<PaywallConfig>(
            future: ConscentMethods().getPaywallConfig(),
            builder: (context, AsyncSnapshot<PaywallConfig> snapshot) {
              // Customize what your widget looks like when it's loading.
              if (!snapshot.hasData) {
                return Center(
                  child: SizedBox(
                    width: 50,
                    height: 50,
                    child: CircularProgressIndicator(
                      color: FlutterFlowTheme.of(context).primaryColor,
                    ),
                  ),
                );
              }
              Constants.paywallConfig = snapshot.data!;
              final paywallconfigResponse = snapshot.data!;

              String? contentDivBtnValue = "";
              String? passDivBtn = "";
              String? subDivBtn = "";
              String? radioBtnOne = "";
              String? radioBtnTwo = "";
              String? radioBtnThree = "";

              contentDivBtnValue = Constants
                  .paywallConfig
                  .data
                  ?.configuration
                  ?.mobile
                  ?.json
                  ?.slotData
                  ?.slot
                  ?.contentDivBtn
                  ?.value;

              Constants.contentPrice="";
              Constants.passPrice="";
              Constants.subscriptionPrice="";

              // content price
              if (contentDivBtnValue == "content") {
                Constants.contentPrice = valueOrDefault<String>(
                  "${Constants.contentDetails2?.microPricing?.price.toString()}",
                  "",
                );
              } else if (contentDivBtnValue == "pass") {
                Constants.contentPrice = valueOrDefault<String>(
                  "${Constants.contentDetails2?.validPass?.price.toString()}",
                  "",
                );
              } else if (contentDivBtnValue == "subscription") {
                Constants.contentPrice = "";
              }

              // pass price
              passDivBtn = Constants.paywallConfig.data?.configuration
                  ?.mobile?.json?.slotData?.slot?.passDivBtn?.value;
              if (passDivBtn == "content") {
                Constants.passPrice = valueOrDefault<String>(
                  "${Constants.contentDetails2?.microPricing?.price.toString()}",
                  "",
                );
              } else if (passDivBtn == "pass") {
                Constants.passPrice = valueOrDefault<String>(
                  "${Constants.contentDetails2?.validPass?.price.toString()}",
                  "",
                );
              } else if (passDivBtn == "subscription") {
                Constants.passPrice = "";
              }

              // subscription price
              subDivBtn = Constants.paywallConfig.data?.configuration
                  ?.mobile?.json?.slotData?.slot?.subDivBtn?.value;
              if (subDivBtn == "content") {
                Constants.subscriptionPrice = valueOrDefault<String>(
                  "${Constants.contentDetails2?.microPricing?.price.toString()}",
                  "",
                );
              } else if (subDivBtn == "pass") {
                Constants.subscriptionPrice = valueOrDefault<String>(
                  "${Constants.contentDetails2?.validPass?.price.toString()}",
                  "",
                );
              } else if (subDivBtn == "subscription") {
                Constants.subscriptionPrice = "";
              }
              print('price ${Constants.contentPrice} ${Constants.passPrice} ${Constants.subscriptionPrice}');


              //RadioBtnOne price
              radioBtnOne = Constants.paywallConfig.data?.configuration
                  ?.mobile?.json?.slotData?.slot?.radioBtnOne?.value;

              if (radioBtnOne == "content") {
                Constants.contentPrice = valueOrDefault<String>(
                  Constants.contentDetails2?.microPricing?.price.toString(),
                  "",
                );
              } else if (radioBtnOne == "pass") {
                Constants.contentPrice = valueOrDefault<String>(
                  Constants.contentDetails2?.validPass?.price.toString(),
                  "",
                );
              } else if (radioBtnOne == "subscription") {
                Constants.contentPrice = "";
              }


              //RadioBtnTwo price
              radioBtnTwo = Constants.paywallConfig.data?.configuration
                  ?.mobile?.json?.slotData?.slot?.radioBtnTwo?.value;

              if (radioBtnTwo == "content") {
                Constants.passPrice = valueOrDefault<String>(
                  Constants.contentDetails2?.microPricing?.price.toString(),
                  "",
                );
              } else if (radioBtnTwo == "pass") {
                Constants.passPrice = valueOrDefault<String>(
                  Constants.contentDetails2?.validPass?.price.toString(),
                  "",
                );
              } else if (radioBtnTwo == "subscription") {
                Constants.passPrice = "";
              }

              //RadioBtnThree price
              radioBtnThree = Constants.paywallConfig.data?.configuration
                  ?.mobile?.json?.slotData?.slot?.radioBtnThree?.value;

              if (radioBtnThree == "content") {
                Constants.subscriptionPrice = valueOrDefault<String>(
                  Constants.contentDetails2?.microPricing?.price.toString(),
                  "",
                );
              } else if (radioBtnThree == "pass") {
                Constants.subscriptionPrice = valueOrDefault<String>(
                  Constants.contentDetails2?.validPass?.price.toString(),
                  "",
                );
              } else if (radioBtnThree == "subscription") {
                Constants.subscriptionPrice = "";
              }

              Constants.contentPrice = (Constants.contentPrice == "") ? "": "${Constants.contentDetails2?.currencySymbol}${Constants.contentPrice}";
              Constants.passPrice = (Constants.passPrice == "") ?"":  "${Constants.contentDetails2?.currencySymbol}${Constants.passPrice}";
              Constants.subscriptionPrice = (Constants.subscriptionPrice == "") ?"":  "${Constants.contentDetails2?.currencySymbol}${Constants.subscriptionPrice}";

              print('price ${Constants.contentPrice} ${Constants.passPrice} ${Constants.subscriptionPrice}');


              if (snapshot.hasData) {
                if ('${paywallconfigResponse.data?.configuration?.mobile?.templateId?.paywallType}${paywallconfigResponse.data?.configuration?.mobile?.templateId?.name}' ==
                    "REGULAR5A") {
                  return Inarticle5A3CTAWidget((response) {
                    widget.sessionCallback(response);
                  });
                } else if ('${paywallconfigResponse.data?.configuration?.mobile?.templateId?.paywallType}${paywallconfigResponse.data?.configuration?.mobile?.templateId?.name}' ==
                    "REGULAR3A") {
                  return InArticle50pageblock3A3CTAWidget((response) {
                    widget.sessionCallback(response);
                  });
                } else if ('${paywallconfigResponse.data?.configuration?.mobile?.templateId?.paywallType}${paywallconfigResponse.data?.configuration?.mobile?.templateId?.name}' ==
                    "REGULAR7A") {
                  return Inarticle7A1CTAWidget((response) {
                    widget.sessionCallback(response);
                  });
                } else if ('${paywallconfigResponse.data?.configuration?.mobile?.templateId?.paywallType}${paywallconfigResponse.data?.configuration?.mobile?.templateId?.name}${paywallconfigResponse.data?.configuration?.mobile?.templateId?.numberOfCta}' ==
                    "REGULAR8A2") {
                  return Inarticle8A2CTAWidget((response) {
                    widget.sessionCallback(response);
                  });
                } else if ('${paywallconfigResponse.data?.configuration?.mobile?.templateId?.paywallType}${paywallconfigResponse.data?.configuration?.mobile?.templateId?.name}${paywallconfigResponse.data?.configuration?.mobile?.templateId?.numberOfCta}' ==
                    "REGULAR8A1") {
                  return InArticle8A1CTAWidget((response) {
                    widget.sessionCallback(response);
                  });
                }
              }
              return DefaultSub((response) {
                widget.sessionCallback(response);
              });
            }),
      ),
    );
  }
}
